import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class TriangleEV extends Frame
{  public int Iter;
   public TriangleEV()
   {  setSize(800,500);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double [][] MultM(double [][] A,double [][] B, int N1,int N2,int N3)
   {  int i,j,k;
      double [][]C = new double[N1][N3];
      for(i=0;i<N1;i++) for(j=0;j<N3;j++)
      {  C[i][j]=0.0;
         for(k=0;k<N2;k++) C[i][j] += A[i][k] * B[k][j];
      }
      return C;
   }
   public double [][] MultEigen(double [] D,double [][] A, int N1,int N2)
   {  int i,j,k;
      double [][]C = new double[N1][N2];
      for(i=0;i<N1;i++) for(j=0;j<N2;j++)
      {  C[i][j] = D[j] * A[i][j];
      }
      return C;
   }

   public double [] MultMV(double [][] A,double [] B, int N1,int N2)
   {  int i,j,k;
      double [] C = new double[N1];
      for(i=0;i<N1;i++)
      {  C[i]=0.0;
         for(k=0;k<N2;k++) C[i] += A[i][k] * B[k];
      }
      return C;
   }
   public double [] MultSV(double A, double [] B, int N)
   {  int i,j,k;
      double [] C = new double[N];
      for(i = 0; i < N; i++) C[i] = A * B[i];
      return C;
   }
   public void copyMat(double[][] A, double[][] B, int N)
   { int i,j;
     for(i = 0;i < N; i++)for(j = 0;j < N; j++) B[i][j] = A[i][j];
   }
   public double [][] TransMat(double[][] A, int N1, int N2)
   { int i,j;
     double [][] T = new double[N1][N2];
     for(i = 0;i < N1; i++)for(j = 0;j < N2; j++) T[j][i] = A[i][j];
     return T;
   }
   public void Trianglize(double [][]A, double[]D, double[]E, double EPS, int N)
   {
     int i, j, k; double S;
     double [] V = new double[N]; double [] W = new double[N];
     for(k = 0; k < N - 2; k++)
     { D[k] = A[k][k]; for(i = k+1; i< N;i++) W[i]  = A[i][k];
       S    = 0      ; for(i = k+1; i< N;i++) S    += W[i] * W[i];
       if(Math.abs(S) > EPS)
       {
          if(W[k + 1] >= 0) S = Math.sqrt(S); else S = - Math.sqrt(S);
          E[k + 1] = - S; W[k + 1] += S; S = 1 / Math.sqrt(W[k + 1] * S);
          for(i = k + 1; i < N; i++) W[i] *= S;
          for(i = k + 1; i < N; i++)
          { S = 0;
            for(j = k + 1; j <= i; j++) S += A[i][j] * W[j];
            for(j = i + 1; j <  N; j++) S += A[j][i] * W[j];
            V[i] = S;
          }
          S =  0; for(i = k+1; i < N; i++) S    += W[i] * V[i];
          S /= 2; for(i = k+1; i < N; i++) V[i] -= S * W[i];
          for(i = k + 1; i < N; i++) for(j = k + 1; j <= i; j++)
                 A[i][j] -= (W[i] * V[j] + W[j] * V[i]);
          //  ŗLxNg߂ƂW̓eAɈڂ
          for(i = k + 1; i < N; i++) A[i][k] = W[i];
       }
       else E[k + 1] = 0;
     }
     D[N - 2] = A[N - 2][N - 2]; D[N - 1] = A[N - 1][N - 1];
     E[0] = 0; E[N - 1] = A[N - 1][N - 2];
     // ȉCŗLxNgvZp
     for(k = N - 1; k >= 0; k--)
     {  if(k < N - 2)
        { for(i = k + 1; i < N; i++) W[i] = A[i][k];
          for(i = k + 1; i < N; i++)
          {  S    = 0; for(j = k + 1; j < N; j++) S += A[i][j] * W[j];
             V[i] = S;
          }
          for(i = k + 1; i< N; i++)for(j = k + 1; j < N; j++) A[i][j] -= V[i] * W[j];
        }
        for(i = 0; i < N; i++) A[i][k] = 0;
        A[k][k] = 1;
     }
   }
   public boolean Zero(double[] D, double[] E, int i)
   { double T;
     
     if (i > 0) T = Math.abs(D[i]) + Math.abs(D[i - 1]); else T = 0;
     return ((T + Math.abs(E[i])) == T);
   }

   public boolean TriEigenValue(double [][] A, double [] D,int N)
   { int i, k, H, L; double S, C, T, W, X, Y, Z;
     int MaxIter = 20; double [] E = new double[N];
     double EPS = 0.00001;  Trianglize(A, D, E, EPS, N);
     E[0] = 1.0; H = N - 1;
     while(Zero(D, E, H)) H--; Iter = 0;

     while (H > 0)
     { E[0] = 0; L = H - 1; while( ! Zero(D, E, L)) L--;
       do
       {  
          Iter++; if(Iter > MaxIter)return false;
          W = (D[H - 1] - D[H]) / 2; S = Math.sqrt(W * W + E[H] * E[H]);
          if(W < 0) S = - S;
          X = D[L] - D[H] + E[H] * E[H] / (W + S); Y = E[L + 1]; Z = 0;
         
         for(k = L; k <= H - 1; k++)
          { if(Math.abs(X) >= Math.abs(Y))
             { T = - Y / X; C = 1.0 / Math.sqrt(T * T + 1); S = T * C;}
             else
             { T = - X / Y; S = 1.0 / Math.sqrt(T * T + 1); if( T < 0 ) S = - S;
               C = T * S;
             }
             W     = D[k] - D[k + 1] ; T    = (W * S + 2 * C * E[k + 1]) * S;
             D[k] -= T; D[k + 1] += T; E[k] = C * E[k] - S * Z;
             E[k + 1] = E[k + 1] * (C * C - S * S) + W * S * C;
             for(i = 0; i < N; i++)
             {   X       = A[k][i]      ; Y           = A[k + 1][i];
                 A[k][i] = C * X - S * Y; A[k + 1][i] = S * X + C * Y;
             }
             if(k < N - 2)
             {    X = E[k + 1]; Y = -S * E[k + 2]; Z = Y; E[k + 2] = C * E[k + 2];
             }
           }
       } while (!Zero(D, E, H));
       E[0] = 1; H --;
       while (Zero(D, E, H)) H--;
     }
     // ȉCŗLxNg
     for(k = 0; k< N - 1; k++)
     { L = k; for(i = k + 1; i < N; i++) if(D[i] > D[L]) L = i;
       T = D[k]; D[k] = D[L]; D[L] = T;
       for(i = 0; i < N ; i++){ T = A[k][i]; A[k][i] = A[L][i]; A[L][i] = T;}
     }
     return true;
   }
   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
   public void DrawData(Graphics g, int Y, double [][] A,int N)
   {  int i, j;
      for(i=0;i<N;i++)
      {
         for(j=0;j<N; j++)
         {  g.drawString( "" + round(A[i][j],3), 50 + j * 50,Y + i * 20);
         }
      }
      drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
   } 

   public void DrawEV(Graphics g,int Y,
                       double [][] A,double [] B, int N)
   {  int i, j;
      for(i=0;i<N;i++)
      { for(j=0;j<N; j++)g.drawString( "" + round(A[i][j],3), 50 + j*50,Y + i*20);
        g.drawString( "" + round(B[i],3),300, Y + i*20);
      }  
      drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
      drawBra(g,290, Y - 10, 70); drawKet(g,350, Y - 10, 70);
   } 
   public void paint(Graphics g)
   {  int i,j;
      double [][] A  ={{4,2,1,1},{2,3,1,2},{1,1,2,1},{1,2,1,4}};
      double [][] W =new double[4][4];
      double []   B  ={0,0,0,0};
      copyMat(A, W, 4);
      setTitle("OdΊp@ɂŗLl");
      g.drawString( "f[^",20,50);
      DrawData(g, 80, A, 4);
      boolean R = TriEigenValue(W, B, 4);
      if(R)
      { g.drawString( "mF (JԂ : " + Iter + " )", 20, 180);
        DrawEV(g, 200, W, B, 4);
        g.drawString( " A * W", 20, 300);
       
        double [][] D = MultM(A,TransMat(W,4,4),4,4,4);
        DrawData(g, 340, D, 4);
        g.drawString( " D * W", 20, 440);
        double [][] E = MultEigen(B, TransMat(W,4,4),4,4);
        DrawData(g, 480, E, 4);
      }
      else g.drawString( "܂", 20, 200);
   } 
   public static void main(String[] args)
   {  Frame w = new TriangleEV();
      w.setVisible(true);
   }
}
